﻿//Configuração de banco de dados
var GetDataBaseType = function (data) {
    switch (data) {
        case 'M':
            $("#TipoBancoDeDados").val('MySQL');
            break;
        case 'S':
            $("#TipoBancoDeDados").val('SQLServer');
            break;
        case 'O':
            $("#TipoBancoDeDados").val('ORACLE');
            break;
        default:
            $("#TipoBancoDeDados").val('MySQL');
            break;
    }
    $('#TipoBancoDeDadosModal').modal('hide');
    SetDefaultConfig(data);
    $('#Endereco').focus();
}

var SetDefaultConfig = function (data) {
    switch (data) {
        case 'M':
            $('#Porta').val('3306');
            break;
        case 'S':
            $('#Porta').val('1433');
            break;
        case 'O':
            $('#Porta').val('1521');
            break;
        default:
            $('#Porta').val('3306');
            break;
    }
}

$("#formConfiguracaoBancoDeDados").on("submit", function (event) {
    event.preventDefault();
    var form = $('#formConfiguracaoBancoDeDados');
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                $('div#retorno').show();
                $('div#retorno').removeClass('alert alert-danger');
                $('div#retorno').addClass('alert alert-success');
                $('#retorno').html(data.message);
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        }, complete: function () {
            $('#btnTesteConexao').trigger('click');
        }
    });
});

$("#btnTesteConexao").on("click", function (event) {
    event.preventDefault();
    var btn = $("#btnTesteConexao");
    var form = $('#formConfiguracaoBancoDeDados');
    var formData = form.serialize();
    var url = $(this).data("request-url");
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                ajaxLoader();
                btn.button('loading');
                $('div#retorno').removeClass('alert alert-danger');
                $('#retorno').html("");
                return true;
            }
            $('div#retorno').removeClass('alert alert-success');
            $('div#retorno').addClass('alert alert-danger');
            $('#retorno').html("Informe todos os campos para efetuar o teste de conexão!");
            return false;
        },
        success: function (data) {
            bootbox.hideAll();
            if (data.status === 'success') {
                $('div#retorno').show();
                $('div#retorno').removeClass('alert alert-danger');
                $('div#retorno').addClass('alert alert-success');
                $('#retorno').html(data.message);
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        }, complete: function () {
            btn.button('reset');
        }
    });
});

var ajaxLoader = function () {
    bootbox.dialog({
        size: "small",
        message: '<p style="text-align:center;"><img src="http://bmasistemas.com/bundles/wpe/images/loaders/bma_loader.gif" /><br />Aguarde, testando conexão...</p>',
        closeButton: false
    })
}

$(function () {
    $('#Porta').mask('00000');
    verificarStatusAcesso();
});

var modalAlterarSenha = $('#AlterarSenhaPrimeiroAcessoModal');

modalAlterarSenha.on('shown.bs.modal', function () {
    limparForm();
    modalAlterarSenha.modal({
        backdrop: false
    });

})

var verificarStatusAcesso = function () {
    var url = $('#verificarAcesso').data('request-url');
    $.ajax({
        url: url,
        type: "POST",
        success: function (data) {
            if (data.status === 'success') {
                if (data.acesso === 0) {
                    modalAlterarSenha.modal({
                        backdrop: 'static'
                    });
                    modalAlterarSenha.modal('show');
                }
            }
        }
    });
}

$("#formAlterarSenhaPrimeiroAcesso").on("submit", function (event) {
    event.preventDefault();
    var form = $(this);
    var formData = $(this).serialize();
    var url = $(this).attr("action");

    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                return true;
            }
            return false;
        },
        success: function (data) {
            var retorno = $('div#retornoSenhaNova');
            if (data.status === 'success') {
                retorno
                    .removeClass('alert alert-danger')
                    .addClass('alert alert-success')
                    .html(data.message)
                    .show();

                modalAlterarSenha.modal('hide');
                bootbox.alert("Senha alterada com sucesso!");
            } else {
                retorno
                    .removeClass('alert alert-success')
                    .addClass('alert alert-danger')
                    .html(data.message)
                    .show();
            }
        }
    });
});

$("#formConfiguracaoEmail").on("submit", function (event) {
    event.preventDefault();
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    var btn = $('#btnEmail');
    var email = $('#Email');
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if ($.trim(email.val()) !== '') {
                btn.button('loading');
                return true;
            }
            email.focus();
            return false;
        },
        success: function (data) {
            var retorno = $('div#retorno');
            if (data.status === 'success') {
                retorno
                    .removeClass('alert alert-danger')
                    .addClass('alert alert-success')
                    .html(data.message)
                    .show();
            } else {
                retorno
                    .removeClass('alert alert-success')
                    .addClass('alert alert-danger')
                    .html(data.message)
                    .show();
            }

            btn.button('reset');
        }, complete: function () {
            $('#btnEmailTeste').trigger('click');
        }
    });
});

$("#formEmailTeste").on("submit", function (event) {
    event.preventDefault();
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    var btn = $('#btnDispararEmailTeste');
    var destinatario = $('#destinatario');
    var retorno = $('div#retornoEmailTeste');
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if ($.trim(destinatario.val()) !== '') {
                btn.button('loading');
                return true;
            }
            retorno
                .removeClass('alert alert-success')
                .addClass('alert alert-danger')
                .html("Informe um e-mail para o teste de e-mail!")
                .show();

            destinatario.focus();
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                retorno
                    .removeClass('alert alert-danger')
                    .addClass('alert alert-success')
                    .html(data.message).show();

                destinatario.val('');
                setTimeout(function () { $('#EmailTesteModal').modal('hide') }, 1500);
            } else {
                retorno
                    .removeClass('alert alert-success')
                    .addClass('alert alert-danger')
                    .html(data.message).show();
            }
            btn.button('reset');
        }
    });
});

$("#formEmailSeguranca").on("submit", function (event) {
    event.preventDefault();
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    var btn = $('#btnEmailSeguranca');
    var email = $('#Email');
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if ($.trim(email.val()) !== '') {
                btn.button('loading');
                return true;
            }
            email.focus();
            return false;
        },
        success: function (data) {
            var retorno = $('div#retorno');

            if (data.status === 'success') {
                retorno
                    .removeClass('alert alert-danger')
                    .addClass('alert alert-success')
                    .html(data.message).show();
            } else {
                retorno
                    .removeClass('alert alert-success')
                    .addClass('alert alert-danger')
                    .html(data.message).show();
            }
            btn.button('reset');
        }
    });
});

$('#formConfiguracaoEmpresa').on('submit', function (event) {
    event.preventDefault();
    var form = $(this);
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                $('div#retorno').show();
                $('div#retorno').removeClass('alert alert-danger');
                $('div#retorno').addClass('alert alert-success');
                $('#retorno').html(data.message);
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        }
    });
});

$('#formConfiguracaoIntegracao').on('submit', function (event) {
    event.preventDefault();
    var form = $(this);
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    $.ajax({
        url: url,
        type: 'POST',
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                $('div#retorno').show();
                $('div#retorno').removeClass('alert alert-danger');
                $('div#retorno').addClass('alert alert-success');
                $('#retorno').html(data.message);
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        }
    });
});


function checkMultiEmpresa(checkbox) {
    $('#EmpresaPadrao, #EstabelecimentoPadrao').attr('readonly', checkbox.prop('checked'));
}

checkMultiEmpresa($('#MultiEmpresa'));

$('#MultiEmpresa').on('change', function () { checkMultiEmpresa($(this)); });

var limparForm = function () {
    $('#senhaAtual').val('');
    $('#senhaNova').val('');
    $('#confirmarSenhaNova').val('');
    $('div#retornoSenhaNova').removeClass('alert alert-danger').removeClass('alert alert-success');
    $('#retornoSenhaNova').html('');
}