﻿var GetJustifyType = function (data) {
    switch (data) {
        case 'A':
            $("#TipoJustificativa").val('Afastamento');
            break;
        case 'E':
            $("#TipoJustificativa").val('Extra');
            break;
        case 'F':
            $("#TipoJustificativa").val('Falta');
            break;
        case 'B':
            $("#TipoJustificativa").val('Abono');
            break;
        default:
            $("#TipoJustificativa").val('Falta');
            break;
    }
    $('#TipoJustificativaModal').modal('hide');
};

//if (!window.chrome) {
$('#Hora').mask('00:00');
//}
$('#Data').mask("00/00/0000", { placeholder: "__/__/____" });
//$('#TipoJustificativa').val('Falta');

//Validar data - REGEX
var validarHora = new RegExp(/^([0-1][0-9]|2[0-3]):[0-5][0-9]$/gi);

//Salvar Justificativa
$("#formCriarJustificativa").on("submit", function (event) {
    event.preventDefault();
    var form = $('#formCriarJustificativa');
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                if ($("#Justificativa").val.length > 100) {
                    errorMessage("Ops! Limite da justificativa é de 100 caracteres!");
                    return false;
                }

                if (validateDate($('#Data').val()) === false) {
                    errorMessage("Ops! A data informada está incorreta!");
                    return false;
                }

                if (validateHour($('#Hora').val()) === false) {
                    errorMessage("Ops! A hora informada está incorreta!");
                    return false;
                }

                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                successMessage(data.message);
                window.setTimeout(location.href = data.url, 1500);
            } else {
                errorMessage(data.message);
            }
        }
    });
});

//Editar Justificativa
$("#formEditarJustificativa").on("submit", function (event) {
    event.preventDefault();
    var form = $('#formEditarJustificativa');
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                if ($("#Justificativa").val.length > 100) {
                    errorMessage("Ops! Limite da justificativa é de 100 caracteres!");
                    return false;
                }

                if (validateDate($('#Data').val()) === false) {
                    errorMessage("Ops! A data informada está incorreta!");
                    return false;
                }

                if (validateHour($('#Hora').val()) === false) {
                    errorMessage("Ops! A hora informada está incorreta!");
                    return false;
                }
                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                successMessage(data.message);
                window.setTimeout(location.href = data.url, 1500);
            } else {
                errorMessage(data.message);
            }
        }
    });
});

/*
    Modal
*/

var ListarJustificativas = function (dataDecimal, dataDiaSemana) {
    showModalJustificativasDoDia(dataDecimal, dataDiaSemana);
};

var countJustify = 0;

var showModalJustificativasDoDia = function (dataDecimal, dataDiaSemana) {
    var url = $('#JustificativasDoDia').data('request-url');
    $.ajax({
        type: "GET",
        url: url,
        contentType: "application/json;charset=utf-8",
        data: { Data: $.trim(dataDecimal) },
        dataType: "json",
        success: function (value) {
            countJustify = value.justificativas.length;
            if (countJustify === 0) {
                $('#Justificativas').attr('hidden', 'hidden');
                $('#SemJustificativas').removeAttr('hidden', 'hidden');
            } else {
                $('#Justificativas').removeAttr('hidden', 'hidden');
                $('#SemJustificativas').attr('hidden', 'hidden');
            }
            $('#dataJustificativa').html(dataDiaSemana);
            BuildTable(value);
            $('#JustificativasDoDia').modal('show');
        }, error: function (data) {
            bootbox.dialog({
                message: "Ocorreu algum erro de conexão com o servidor. Aguarde um momento e tente novamente!",
                title: "Atenção!",
                buttons: {
                    main: {
                        label: "Ok",
                        className: "btn-primary"
                    }
                }
            });
        }
    });
};

$('#JustificativasDoDia').on('hidden.bs.modal', function (e) {
    if (countJustify === 0) {
        location.reload();
    }
});

function BuildTable(value) {
    var table = '<table class="table table-hover table-striped"><thead><tr><th>Hora</th><th>Justificativa</th><th>Status</th><th></th></thead><tbody>';

    for (i = 0; i < value.justificativas.length; i++) {
        var visualizar = "VisualizarJustificativa('" + value.justificativas[i].Id + "');";
        var row = "<tr>";
        row += "<td>" + value.justificativas[i].Hora.toString() + "</td>";
        row += "<td>" + value.justificativas[i].Justificativa.toString() + "</td>";
        switch (value.justificativas[i].Status.toString()) {
            case "A":
                row += "<td><span class='label label-success'>Aprovada</span></td>";
                break;
            case "R":
                row += "<td><span class='label label-danger'>Reprovada</span></td>";
                break;
            case "P":
                row += "<td><span class='label label-warning'>Pendente</span></td>";
                break;
            default:
        }
        if (value.justificativas[i].Status.toString() === 'R') {
            row += "<td><a href='javascript:void(0)' onclick=" + visualizar + " class='btn btn-info btn-sm btn-motivo' data-loading-text='Aguarde...'>Visualizar Motivo</a></td>";
        } else {
            row += "<td><a href='javascript:void(0)' onclick=" + visualizar + " class='btn btn-default btn-sm btn-motivo' data-loading-text='Aguarde...'>Visualizar</a></td>";
        }
        row += "</tr>";
        table += row;
    }
    $('#Justificativas').html(table);
}

function VisualizarJustificativa(id) {
    $.ajax({
        type: "GET",
        url: $('#vwJustify').data('request-url'),
        contentType: "application/json;charset=utf-8",
        data: { id: id },
        dataType: "json",
        success: function (value) {
            if (value.status === 'success') {
                JustificativaDetalhes(value);
            } else {
                bootbox.dialog({
                    message: value.message,
                    title: "Alerta!",
                    buttons: {
                        main: {
                            label: "Ok",
                            className: "btn-primary"
                        }
                    }
                });
            }
        }, error: function () {
            bootbox.dialog({
                message: "Ocorreu algum erro de conexão com o servidor. Aguarde um momento e tente novamente!",
                title: "Atenção!",
                buttons: {
                    main: {
                        label: "Ok",
                        className: "btn-primary"
                    }
                }
            });
        }
    });
}

function JustificativaDetalhes(value) {
    if (value.status === 'success') {
        $('.modal-title').html("Justificativa");
        var conteudo = "<dl class='dl-horizontal'>";
        conteudo += "<dt>Data:</dt>";
        conteudo += "<dd id='DataJustificativa'>" + value.justificativa.Data + "</dd>";
        conteudo += "<dt>Hora:</dt>";
        conteudo += "<dd id='HoraJustificativa'>" + value.justificativa.Hora + "</dd>";
        conteudo += "<dt>Tipo Justificativa:</dt>";

        switch (value.justificativa.TipoJustificativa) {
            case 'A':
                conteudo += "<dd><span class='label label-success'>Afastamento</span></dd>";
                break;
            case 'E':
                conteudo += "<dd><span class='label label-success'>Extra</span></dd>";
                break;
            case 'F':
                conteudo += "<dd><span class='label label-success'>Falta</span></dd>";
                break;
            case 'B':
                conteudo += "<dd><span class='label label-success'>Abono</span></dd>";
                break;
            default:
                conteudo += "<dd><span class='label label-success'>Outros</span></dd>";
                break;
        }
        conteudo += "<dt>Status:</dt>";
        switch (value.justificativa.Status) {
            case 'A':
                conteudo += "<dd><span class='label label-success'>Aprovado</span></dd>";
                break;
            case 'R':
                conteudo += "<dd><span class='label label-danger'>Reprovado</span></dd>";
                break;
            case 'P':
                conteudo += "<dd><span class='label label-warning'>Pendente</span></dd>";
                break;
        }
        conteudo += "<dt>Justificativa:</dt>";
        conteudo += "<dd>" + value.justificativa.Justificativa + "</dd>";
        if (value.justificativa.Status === 'R') {
            conteudo += "<hr />";
            $('.modal-title').html("Motivo da Reprovação");
            conteudo += "<dt>Motivo da reprovação:</dt>";
            conteudo += "<dd>" + value.justificativa.JustificativaSupervisor + "</dd>";
            conteudo += "<dt>Supervisor:</dt>";
            conteudo += "<dd>" + value.justificativa.Supervisor + "</dd>";
            conteudo += "<dt>Data da reprovação:</dt>";
            conteudo += "<dd>" + value.justificativa.DataJustificativaSupervisor + "</dd>";
            conteudo += "<dt>Hora da reprovação:</dt>";
            conteudo += "<dd>" + value.justificativa.HoraJustificativaSupervisor + "</dd>";
        }
        conteudo += "</dl>";
        $('#Motivo').html(conteudo);
        if (value.justificativa.Status === 'P') {
            $('#Menu').html("<button type='button' id='btnExcluirJustificativa' class='btn btn-danger btn-md btn-block' onclick='ExcluirJustificativa(" + value.justificativa.Id + ");' data-loading-text='Aguarde...'>Excluir justificativa</button>");
        }
        $('#JustificativaMotivo').modal('show');
    } else {
        bootbox.dialog({
            message: status.message,
            title: "Atenção!",
            buttons: {
                main: {
                    label: "Ok",
                    className: "btn-primary"
                }
            }
        });
    }
}

$('#JustificativaModal').on('hidden.bs.modal', function (e) {
    limparFormJustificativa();
});

$("#btnCadastrar").on("click", function (event) {
    event.preventDefault();
    var form = $('form#formJustificativaModal');
    var formData = form.serialize();
    var returnUrl;
    var status = false;
    $.ajax({
        url: $(this).data('request-url'),
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                if ($("#Justificativa").val.length > 100) {
                    errorMessage("Ops! Limite da justificativa é de 100 caracteres!");
                    return false;
                }

                if (validateDate($('#Data').val()) === false) {
                    errorMessage("Ops! A data informada está incorreta!");
                    return false;
                }

                if (validateHour($('#Hora').val()) === false) {
                    errorMessage("Ops! A hora informada está incorreta!");
                    return false;
                }

                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                successMessage(data.message);
                returnUrl = data.url;
                status = true;
                limparFormJustificativa();
            } else {
                errorMessage(data.message);
            }
        },
        complete: function () {
            if (status === true) {
                window.setTimeout(fecharModal, 1500);
                location.reload();
            }
        }
    });
});

function ExcluirJustificativa(id) {
    var btn = $('#btnExcluirJustificativa');
    bootbox.dialog({
        message: "Deseja mesmo excluir esta justificativa pendente?",
        title: "Confirmar",
        buttons: {
            danger: {
                label: "Sim",
                className: "btn-danger",
                callback: function () {
                    $.ajax({
                        url: $('#delJustify').data('request-url'),
                        type: "POST",
                        data: { id: id },
                        beforeSend: function () {
                            btn.button('loading');
                        },
                        success: function (value) {
                            btn.button('reset');
                            if (value.status !== 'error') {
                                btn.hide();

                                PNotify.desktop.permission();
                                new PNotify({
                                    title: 'Notificação',
                                    text: 'Justificatica excluída com sucesso!',
                                    type: 'success',
                                    delay: 3000,
                                    desktop: {
                                        desktop: true
                                    },
                                    buttons: {
                                        sticker: false
                                    }
                                });

                                //$('#retornoMotivo').html("<div class='alert alert-success' role='alert'>Justificativa excluida com sucesso!</div>");
                                var data = $.trim($('#DataJustificativa').html());
                                window.setTimeout(ListarJustificativas(data.substr(6, 4) + data.substr(3, 2) + data.substr(0, 2), $('#DataJustificativa').html()), 2000);
                                $('div#JustificativaMotivo').modal('hide');
                                //$('#retornoMotivo').empty();
                            } else {
                                btn.attr("disabled", "disabled");
                                $('#retornoMotivo').html("<br /><div class='alert alert-danger' role='alert'>" + value.message + "</div>");
                            }
                        }
                    });
                }
            },
            main: {
                label: "Não",
                className: "btn-primary"
            }
        }
    });
}

function NovaJustificativa(data) {
    data = $.trim(data);
    data = data.substr(6, 2) + "/" + data.substr(4, 2) + "/" + data.substr(0, 4);
    $('#Data').val(data);
    $('#JustificativaModal').modal('show');
}

var validateHour = function (value) {
    var hour = value.substring(0, 2);
    var minutes = value.substring(3, 5);

    return hour >= 0 && hour < 24 && minutes >= 0 && minutes <= 59;
};

var validateDate = function (value) {
    var day = value.substring(0, 2);
    var month = value.substring(3, 5);
    var year = value.substring(6, 10);

    if (day < 1 || (day < 1 || day > 30) && (month == 4 || month == 6 || month == 9 || month == 11) || day > 31) {
        return false;
    }

    if (month < 1 || month > 12) {
        return false;
    }

    //bissexto
    if (month == 2 && (day < 1 || day > 29 || (day > 28 && parseInt(year / 4) != year / 4))) {
        return false;
    }

    return true;
};

function redirect() {
    window.location.href = $('#returnUrl').val();
    //parent.history.back();
    //return false;
}

var errorMessage = function (message) {
    $('#retorno').html(message).show();
    $('div#retorno').removeClass('alert alert-success');
    $('div#retorno').addClass('alert alert-danger');
};

var successMessage = function (message) {
    $('#retorno').show();
    $("#retorno").fadeOut(5000, "linear");
    $('div#retorno').removeClass('alert alert-danger');
    $('div#retorno').addClass('alert alert-success');
    $('#retorno').html(message);
};

$(".dropdown-menu li a").click(function () {
    $("#TipoJustificativa").val($(this).text());
    //document.getElementById("form").submit();
});

$('#Total').text("100");
$('#Justificativa').keyup(function () {
    var tamanho = $(this).val().length;
    if (tamanho <= 100) {
        var total = 100 - tamanho;
        $('#Total').text(total);
    }
});

function fecharModal() {
    $('div#JustificativaModal').modal('hide');
}

var limparFormJustificativa = function () {
    $('#Data').val('');
    $('#Hora').val('');
    $('#TipoJustificativa').val('');
    $('#Justificativa').val('');
};

//Utilizado direto na tela de listagem das marcações, quando houver alterações nos js que fica na tela de listagem, alterar este tbm.
//function VisualizarJustificativa(id) {
//    $.ajax({
//        type: "GET",
//        url: "@Url.Action("VisualizarMotivo","Justificativa")",
//        contentType: "application/json;charset=utf-8",
//    data: { id: id },
//    dataType: "json",
//    beforeSend: function () {
//        $('.btn .btn-sm .btn-info').button('loading');
//    },
//    success: function (value) {
//        if (value.status === 'success') {
//            $('.modal-title').html("Justificativa");
//            var conteudo = "<dl class='dl-horizontal'>";
//            conteudo += "<dt>Data:</dt>";
//            conteudo += "<dd>" + value.justificativa.Data + "</dd>";
//            conteudo += "<dt>Hora:</dt>";
//            conteudo += "<dd>" + value.justificativa.Hora + "</dd>";
//            conteudo += "<dt>Tipo Justificativa:</dt>";

//            switch (value.justificativa.TipoJustificativa) {
//                case 'A':
//                    conteudo += "<dd><span class='label label-success'>Afastamento</span></dd>";
//                    break;
//                case 'E':
//                    conteudo += "<dd><span class='label label-success'>Extra</span></dd>";
//                    break;
//                case 'F':
//                    conteudo += "<dd><span class='label label-success'>Falta</span></dd>";
//                    break;
//                default:
//                    conteudo += "<dd><span class='label label-success'>Outros</span></dd>";
//                    break;
//            }
//            conteudo += "<dt>Status:</dt>";
//            switch (value.justificativa.Status) {
//                case 'A':
//                    conteudo += "<dd><span class='label label-success'>Aprovado</span></dd>";
//                    break;
//                case 'R':
//                    conteudo += "<dd><span class='label label-danger'>Reprovado</span></dd>";
//                    break;
//                case 'P':
//                    conteudo += "<dd><span class='label label-warning'>Pendente</span></dd>";
//                    break;
//            }
//            conteudo += "<dt>Justificativa:</dt>";
//            conteudo += "<dd>" + value.justificativa.Justificativa + "</dd>";
//            if (value.justificativa.Status === 'R') {
//                conteudo += "<hr />";
//                $('.modal-title').html("Motivo da Reprovação");
//                conteudo += "<dt>Motivo da reprovação:</dt>";
//                conteudo += "<dd>" + value.justificativa.JustificativaSupervisor + "</dd>";
//                conteudo += "<dt>Supervisor:</dt>";
//                conteudo += "<dd>" + value.justificativa.Supervisor + "</dd>";
//                conteudo += "<dt>Data da reprovação:</dt>";
//                conteudo += "<dd>" + value.justificativa.DataJustificativaSupervisor + "</dd>";
//                conteudo += "<dt>Hora da reprovação:</dt>";
//                conteudo += "<dd>" + value.justificativa.HoraJustificativaSupervisor + "</dd>";
//            }
//            conteudo += "</dl>";

//            $('#Motivo').html(conteudo);
//            $('#JustificativaMotivo').modal('show');
//            $('.btn .btn-sm .btn-info').button('reset');
//        } else {
//            alert(status.message);
//        }
//    }, error: function () {
//        alert('Verifique sua conexão de internet e tente novamente!');
//    }
//});
//}

//var ListarJustificativas = function (dataDecimal, dataDiaSemana) {
//    $.ajax({
//        type: "GET",
//        url: "@Url.Action("ListarPorData","Justificativa")",
//        contentType: "application/json;charset=utf-8",
//    data: { Data: $.trim(dataDecimal) },
//    dataType: "json",
//    success: function (value) {
//        $('#dataJustificativa').html(dataDiaSemana);
//        BuildTable(value);
//        $('#JustificativasDoDia').modal('show');
//    }, error: function () {
//        alert('Verifique sua conexão de internet e tente novamente!');
//    }
//});
//}

//$("#btnCadastrar").on("click", function (event) {
//    event.preventDefault();
//    var form = $('form#formJustificativaModal');
//    var formData = form.serialize();
//    var returnUrl;
//    var status = false;
//    $.ajax({
//        url: "@Url.Action("CriarJustificativa","Justificativa")",
//        type: "POST",
//    data: formData,
//    beforeSend: function () {
//        if (form.valid()) {
//            if ($("#Justificativa").val.length > 100) {
//                errorMessage("Ops! Limite da justificativa é de 100 caracteres!");
//                return false;
//            }

//            if (validateDate($('#Data').val()) === false) {
//                errorMessage("Ops! A data informada está incorreta!");
//                return false;
//            }

//            if (validateHour($('#Hora').val()) === false) {
//                errorMessage("Ops! A hora informada está incorreta!");
//                return false;
//            }

//            return true;
//        }
//        return false;
//    },
//    success: function (data) {
//        if (data.status === 'success') {
//            successMessage(data.message);
//            returnUrl = data.url;
//            status = true;
//            limparFormJustificativa();
//        } else {
//            errorMessage(data.message);
//        }
//    },
//    complete: function () {
//        if (status === true) {
//            window.setTimeout(fecharModal, 2000);
//        }
//    }
//});
//});

//$('#JustificativaModal').on('hidden.bs.modal', function (e) {
//    limparFormJustificativa();
//})

//var limparFormJustificativa = function () {
//    $('#Data').val('');
//    $('#Hora').val('');
//    $('#TipoJustificativa').val('');
//    $('#Justificativa').val('');
//}