﻿$("#formMarcacao").on("submit", function (event) {
    event.preventDefault();
    getLocation();
    var form = $('#formMarcacao');
    var formData = $(this).serialize();
    var url = $(this).attr("action");
    var returnUrl = $('#returnUrl');
    var status = false;
    $.ajax({
        url: url,
        type: "POST",
        data: formData,
        beforeSend: function () {
            if (form.valid()) {
                $('#btnEfetuarMarcacao').button('loading');
                return true;
            }
            return false;
        },
        success: function (data) {
            if (data.status === 'success') {
                $('div#retorno').show();
                $('div#retorno').removeClass('alert alert-danger');
                $('div#retorno').addClass('alert alert-success');
                $('#retorno').html(data.message).html(data.message);
                removerMensagem();
                //returnUrl.val(data.url);
                listarMarcacoesDoDia();
                //$('a#btnBancoDeHoras').trigger('submit');
                status = true;
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        },
        complete: function () {
            //if (status === true) {
            //    window.setTimeout(redirect, 1500);
            //}
            $('#btnEfetuarMarcacao').button('reset');
            // $('#Senha').val('');
        }
    });
});

function removerMensagem() {
    window.setTimeout(function () { $('#retorno').hide(); }, 3000);
}

function redirect() {
    window.location.href = $('#returnUrl').val();
    //parent.history.back();
    //return false;
}

function listarMarcacoesDoDia() {
    var url = $('div#mco_request').data("request-url");
    $.ajax({
        url: url,
        type: "GET",
        success: function (data) {
            if (data.status === 'success') {
                BuildTableMarcacoes(data);
            } else {
                $('#retorno').show();
                $('div#retorno').removeClass('alert alert-success');
                $('div#retorno').addClass('alert alert-danger');
                $('#retorno').html(data.message);
            }
        }
    });
}


var BuildTableMarcacoes = function (value) {
    var table = '<table class="table table-hover table-striped"><thead><tr><th>#</th><th>Data</th><th>Horário</th><th>Status</th></thead><tbody>';
    for (i = 0; i < value.marcacoes.length; i++) {
        var visualizar = "VisualizarJustificativa('" + value.marcacoes[i].Id + "');";
        var row = "<tr>";
        row += "<td>" + value.marcacoes[i].Sequencia + "</td>";
        row += "<td>" + value.marcacoes[i].Data + "</td>";
        row += "<td>" + value.marcacoes[i].Hora + "</td>";
        switch (value.marcacoes[i].Status) {
            case "S":
                row += "<td><span class='label label-success'>Aprovada</span></td>";
                break;
            case "N":
                row += "<td><span class='label label-warning'>Pendente</span></td>";
                break;
            default:
                row += "<td><span class='label label-warning'>Pendente</span></td>";
                break;
        }
        row += "</tr>";
        table += row;
    }
    table += "</table>";
    $('#mco_pendentes').html(table);
    if (value.marcacoes.length > 0) {
        $('#mco_titulo').html("Marcações do dia");
    } else {
        $('#mco_titulo').html("Você não possui marcações");
    }
};

var positionStatus = 0;

function getLocation() {
    getTimestamp();
    if (navigator.geolocation) {
        var watchId = navigator.geolocation.watchPosition(getPosition, showError, {
            enableHighAccuracy: true,
            maximumAge: 30000,
            timeout: 27000
        });
        checkGeoloc();
    }
}

function checkGeoloc() {
    setTimeout(function () {
        if (positionStatus === 0) {
            $('div#retorno').show();
            $('div#retorno').removeClass('alert alert-success');
            $('div#retorno').addClass('alert alert-danger');
            $('div#retorno').html("Localização não permitida por usuário");
        } else if (positionStatus === 1) {
            $('div#retorno').hide();
        }
    }, 2000);
}

function getTimestamp() {
    $('#Gmt').val(Date().toLocaleString().split('GMT')[1].split('(')[0].trim());
}

function getPosition(position) {
    positionStatus = 1;
    checkGeoloc();
    $('#Latitude').val(position.coords.latitude);
    $('#Longitude').val(position.coords.longitude);
}

function showError(error) {
    positionStatus = 2;
    $('div#retorno').show();
    $('div#retorno').removeClass('alert alert-success');
    $('div#retorno').addClass('alert alert-danger');
    switch (error.code) {
        case error.PERMISSION_DENIED:
            $('div#retorno').html("Localização negada pelo browser.");
            break;
        case error.POSITION_UNAVAILABLE:
            $('div#retorno').html("Informação de localização indisponível.");
            break;
        case error.TIMEOUT:
            $('div#retorno').html("Timeout no request de localização do usuário.");
            break;
        case error.UNKNOWN_ERROR:
            $('div#retorno').html("Ocorreu um erro desconhecido ao buscar a localização do usuário.");
            break;
    }
}


$(function () {
    listarMarcacoesDoDia();
    getLocation();
});