﻿var notificacoes = [];

//Solicita total de notificações pendentes.
function totalNotifications(status, ignoreError) {
    var totalNotificacoes = $('#nt_total');
    $.ajax({
        type: "POST",
        url: totalNotificacoes.data('request-url'),
        data: { statusNotificacao: status },
        dataType: "json",
        success: function (result) {
            if (!result.isValid) {
                if (!ignoreError) {
                    errorAlert(result.message);
                }
                return;
            }

            if (result.count > 0) {
                $('#sinalizador').removeClass('hidden');
                $('#bell').addClass('animated swing');
                totalNotificacoes.html(result.count > 10 ? "10+" : result.count);
                return;
            }

            $('#bell').removeClass('animated swing');
            $('#sinalizador').addClass('hidden');
        }, error: function () {
            if (!ignoreError) {
                errorAlert("Ocorreu um erro durante o carregamento das notificações!");
            }
        }
    });
}

function errorAlert(message, title) {
    bootbox.hideAll();
    console.log(message);
    bootbox.dialog({
        message: message,
        title: title || "Atenção!",
        buttons: {
            main: {
                label: "Ok",
                className: "btn-primary"
            }
        }
    });
}

//Cria listagem de notificações.
function BuildNotifications(lista) {
    var rows = "<div class='notifications-wrapper'>";

    if (lista.length > 0) {
        $('#titleNotifications').addClass('notifications-title').removeClass('notifications-title-no-contains');
        $('#titleNotifications').html("Você possui notificações pendentes");
    } else {
        $('#titleNotifications').addClass('notifications-title-no-contains').removeClass('.notifications-title');
        $('#titleNotifications').html("Você não possui notificações pendentes");
        $('#notificationsList').html("<div class='col-md-5 col-md-offset-5' style='margin-top:10px;overflow-y:hidden;'><i class='fa fa-3x fa-thumbs-o-up'></i></div>");
        return;
    }
    for (i = 0; i < lista.length; i++) {
        var action = "viewNotification(" + lista[i].Id + ");";
        rows += "<div class='content' onclick='" + action + "'>";
        rows += "<div class='notification-item'>";
        rows += "<h4 class='item-title'>";
        rows += "<strong>" + lista[i].Titulo + "</strong>";
        rows += "<span class='label label-warning pull-right'>Não Lida</span>";
        rows += "</h4>";
        rows += "<p class='item-info'>";
        rows += "<span class='help-block'>" + (lista[i].Descricao.length > 50 ? lista[i].Descricao.substr(0, 50) + "&hellip;" : lista[i].Descricao) + " <a href='javascript:void(0)'> <span class='pull-right'>" + lista[i].TempoPassado + "</span></a></span>";
        rows += "</p>";
        rows += "</div>";
        rows += "</div>";
    }

    rows += "</div>";
    $('#notificationsList').html(rows);
}

function viewNotification(id) {
    if (window.event.target.nodeName === 'SPAN') {
        return;
    }

    for (var i = 0; i < notificacoes.length; i++) {
        if (notificacoes[i].Id == id) {
            notificationModal(notificacoes[i]);
            changeNotificationStatus(notificacoes[i].Id, 1);
            return;
        }
    }

    $.ajax({
        type: "POST",
        url: $('#nt_notificacao').data('request-url'),
        data: { id: id },
        dataType: "json",
        success: function (result) {
            notificationModal(result.notificacao);
            changeNotificationStatus(result.notificacao.Id, 1);
        }, error: function () {
            errorAlert("Ocorreu um erro durante o carregamento das notificações!");
        }
    });
}

function changeNotificationStatus(id, status) {
    $.ajax({
        type: "POST",
        url: $('#nt_notificacaoStatus').data('request-url'),
        data: { id: id, statusNotificacao: status },
        dataType: "json",
        success: function (result) {
            if (!result.isValid) {
                errorAlert(result.message);
                return;
            }

            totalNotifications(0);

            var statusNotificacao;
            var classe;

            switch (status) {
                case 1:
                    classe = 'success';
                    statusNotificacao = 'Lida';
                    break;
                case 0:
                default:
                    classe = 'warning';
                    statusNotificacao = 'Não lida';
                    break;
            }

            $('#' + id).children('td').last().children('span').attr('class', 'label label-' + classe).text(statusNotificacao);

        }, error: function () {
            errorAlert("Ocorreu um erro durante o carregamento das notificações!");
        }
    });
}

var notificationModal = function (notificacao) {
    //var descricao = "<div><h4 class='item-title'><strong>" + value.notificacao.Titulo + "</strong></h4><p class='item-info'><span class='help-block'>" + value.notificacao.Descricao + " <a href='javascript:void(0)'> <span class='pull-right'>" + value.notificacao.DataHoraNotificacao + "</span></a></span></p></div>";
    var descricao = "<div><p class='item-info'><span>" + notificacao.Descricao + " <a href='javascript:void(0)'></a></span></p><p><span class='pull-right help-block'>" + notificacao.TempoPassado + "</span></p><br /></div>";
    var modal = "<div id='notificationModal' class='modal fade in'>";
    modal += "<div class='modal-dialog'>";
    modal += "<div class='modal-content'>";
    modal += "<div class='modal-header'>";
    modal += "<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>";
    modal += "<h4 class='modal-title'>" + notificacao.Titulo + "</h4>";
    modal += "</div>";
    modal += "<div class='modal-body'>";
    modal += descricao;
    modal += "</div>";
    modal += "<div class='modal-footer'>";
    modal += "<button type='button' class='btn btn-default' data-dismiss='modal'>Sair</button>";
    modal += "</div>";
    modal += "</div>";
    modal += "</div>";
    modal += "</div>";
    $('#notification').html(modal);
    $('#notificationModal').modal('show');
};

function loadNotifications(status, page, pageSize) {
    $.ajax({
        type: "POST",
        url: $('#notifications').data('request-url'),
        dataType: "json",
        data: { page: page || 1, pageSize: pageSize || 10, statusNotificacao: status },
        beforeSend: function () {
            $('#notifyLoader').removeClass('hidden');
            $('#notificationsList').empty();
        },
        success: function (result) {
            $('#notifyLoader').addClass('hidden');

            if (!result.isValid) {
                errorAlert(result.message);
                return;
            }

            if (result.count > 0) {
                $('#sinalizador').removeClass('hidden');
                $('#bell').addClass('animated swing');
                $('#nt_total').html(result.count > 10 ? "10+" : result.count);
            }
            notificacoes = result.lista;

            BuildNotifications(notificacoes);
        }
    });
}

function viewAll() {
    $.ajax({
        type: "POST",
        url: $('#viewAll').attr('request-url'),
        success: function (result) {
            if (result.isValid) {
                totalNotifications(0);
            }
        }
    });
}

$(function () {
    //var url = window.location.pathname;
    //Verifica total de notificações no primeiro carregamento da página.
    totalNotifications(0);
    //Verifica total de noticações pendentes a cada 5min.
    setInterval(function () { totalNotifications(0, true); }, 300000);
});